'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp, _initialiseProps; /**
                                      * 日历
                                      */


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./Calendar.scss');

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rowNumber = 6;
var colNumber = 7;

var Calendar = (_temp = _class = function (_Component) {
	(0, _inherits3.default)(Calendar, _Component);

	function Calendar(props) {
		(0, _classCallCheck3.default)(this, Calendar);

		var _this = (0, _possibleConstructorReturn3.default)(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props));

		_initialiseProps.call(_this);

		var date = props.date;

		var _this$getCurrentInfo = _this.getCurrentInfo(date.getFullYear(), parseInt(date.getMonth()) + 1),
		    year = _this$getCurrentInfo.year,
		    month = _this$getCurrentInfo.month,
		    data = _this$getCurrentInfo.data;

		_this.state = {
			curYear: year,
			curMonth: month,
			curData: data
		};
		return _this;
	}

	(0, _createClass3.default)(Calendar, [{
		key: 'componentWillMount',
		value: function componentWillMount() {}
		// -- start 外部调用

		// -- end


		// 创建每个月天数的数组


		// 获取某月的天数


		// 根据日期判断是星期几


		// 小于10的数字前面加0

	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    className = _props.className,
			    weekClassName = _props.weekClassName;

			var classes = "c-calendar " + className;
			var weekClasses = "__flex-col __tc " + weekClassName;
			return _react2.default.createElement(
				'div',
				{ className: classes },
				_react2.default.createElement(
					'div',
					{ className: '__header __flex-ac' },
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u65E5'
					),
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u4E00'
					),
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u4E8C'
					),
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u4E09'
					),
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u56DB'
					),
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u4E94'
					),
					_react2.default.createElement(
						'span',
						{ className: weekClasses },
						'\u516D'
					)
				),
				this.renderCalendar()
			);
		}
	}]);
	return Calendar;
}(_react.Component), _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.next = function () {
		var _state = _this2.state,
		    curYear = _state.curYear,
		    curMonth = _state.curMonth;

		return _this2.setDate(curYear, curMonth + 1);
	};

	this.prev = function () {
		var _state2 = _this2.state,
		    curYear = _state2.curYear,
		    curMonth = _state2.curMonth;

		return _this2.setDate(curYear, curMonth - 1);
	};

	this.setDate = function (year, month) {
		var _getCurrentInfo = _this2.getCurrentInfo(year, month),
		    _year = _getCurrentInfo.year,
		    _month = _getCurrentInfo.month,
		    data = _getCurrentInfo.data;

		_this2.setState({
			curYear: _year,
			curMonth: _month,
			curData: data
		});

		return {
			year: _year,
			month: _month
		};
	};

	this.getCurrentInfo = function (year, month) {
		var prevYear = void 0,
		    nextYear = void 0,
		    prevMonth = void 0,
		    nextMonth = void 0,
		    prevData = void 0,
		    curData = void 0,
		    nextData = void 0;

		// 处理下当前值
		if (month === 0) {
			year = year - 1;
			month = 12;
		} else if (month === 13) {
			year = year + 1;
			month = 1;
		}

		prevYear = year;
		nextYear = year;
		prevMonth = month - 1;
		nextMonth = month + 1;

		// 处理前后值
		if (month === 1) {
			prevYear = year - 1;
			prevMonth = 12;
		} else if (month === 12) {
			nextYear = year + 1;
			nextMonth = 1;
		}

		prevData = _this2.createDaysArray(prevYear, prevMonth, _this2.getMonthDays(prevYear, prevMonth), 'prev');
		curData = _this2.createDaysArray(year, month, _this2.getMonthDays(year, month), 'current');
		nextData = _this2.createDaysArray(nextYear, nextMonth, _this2.getMonthDays(nextYear, nextMonth), 'next');

		// 生成日历数组
		var firstWeek = _this2.getWeek(year + '-' + _this2.formatNum(month) + '-1'); // 本月第一天是星期几
		var data = [].concat((0, _toConsumableArray3.default)(prevData.slice(prevData.length - (firstWeek === 0 ? 7 : firstWeek), prevData.length)), (0, _toConsumableArray3.default)(curData), (0, _toConsumableArray3.default)(nextData.slice(0, 42 - firstWeek - curData.length)));

		return {
			year: year,
			month: month,
			data: data
		};
	};

	this.createDaysArray = function (year, month, days, type) {
		var array = [];
		for (var i = 0; i < days; i++) {
			var item = {};
			item.date = year + '-' + _this2.formatNum(month) + '-' + _this2.formatNum(i + 1);
			item.day = i + 1;
			item.type = type;
			array.push(item);
		}
		return array;
	};

	this.getMonthDays = function (year, month) {
		var day = new Date(year, month, 0);
		return day.getDate();
	};

	this.getWeek = function (dateString) {
		var date = void 0;
		if (!dateString) {
			date = new Date();
		} else {
			var dateArray = dateString.split('-');
			date = new Date(dateArray[0], parseInt(dateArray[1] - 1), dateArray[2]);
		}

		// return "星期" + "日一二三四五六".charAt(date.getDay());
		return date.getDay();
	};

	this.formatNum = function (num) {
		if (num < 10) {
			return '0' + num;
		}
		return num;
	};

	this.renderCalendar = function () {
		var table = [];
		for (var i = 0; i < rowNumber; i++) {
			table[i] = _this2.renderRow(i + 1);
		}

		return _react2.default.createElement(
			'div',
			{ className: '__flex-ac __bg-white __fd-c' },
			table
		);
	};

	this.renderRow = function (rowNum) {
		var _props2 = _this2.props,
		    tipInfo = _props2.tipInfo,
		    renderRow = _props2.renderRow,
		    _onSelect = _props2.onSelect,
		    selected = _props2.selected;
		var curData = _this2.state.curData;

		var rowData = curData.slice((rowNum - 1) * 7, rowNum * 7);
		return _react2.default.createElement(
			'div',
			{ className: '__flex-ac __bg-white', style: { width: '100%' }, key: rowData[0].date },
			rowData.map(function (item, index) {
				return _react2.default.createElement(renderRow, {
					key: rowNum + '-' + index,
					itemData: item,
					onSelect: function onSelect(param) {
						return _onSelect && _onSelect(param || item);
					},
					select: selected.includes(item.date)
				});
			})
		);
	};
}, _temp);


Calendar.propTypes = {
	renderRow: _propTypes2.default.func,
	selected: _propTypes2.default.array,
	className: _propTypes2.default.string,
	weekClassName: _propTypes2.default.string
};
Calendar.defaultProps = {
	renderRow: _Item2.default,
	date: new Date(),
	selected: []
};

exports.default = Calendar;